
import { make_data_dir } from '../files';
import { StorageProvider } from '../provider';
import { FileStorageConfig } from './config';
import { create_session, get_session, delete_session, cleanup_old_sessions } from './sessions';

export function create_file_storage_provider(conf: FileStorageConfig) : StorageProvider {
	// Create any directories needed
	const ready = Promise.all([
		make_data_dir('sessions'),
	]);

	return {
		ready,
		
		// Login Sessions
		create_session,
		get_session,
		delete_session,
		cleanup_old_sessions,
	};
}
