
import type { Snowflake } from '../utilities/snowflake-uid';

export interface StorageProvider {
	readonly ready: Promise<void | void[]>;

	// Login Sessions
	create_session(data: SessionData) : Promise<void>;
	get_session(prefix: string) : Promise<SessionData>;
	delete_session(prefix: string) : Promise<void>;
	cleanup_old_sessions() : Promise<void>;

	// todo: fill in with app-data-specific methods
}

export interface SessionData {
	prefix: string;
	key_hash: string;
	oidc_subject: string;
	user_id: Snowflake;
	started: Date;
	expires: Date;
}
